# MPI_T_pvar_handle_alloc

Allocate a handle for a performance variable

## Synopsis

    int MPI_T_pvar_handle_alloc(MPI_T_pvar_session session, int pvar_index,
                                void *obj_handle, MPI_T_pvar_handle *handle, int *count)

## Input Parameters

session
  identifier of performance experiment session (handle)
pvar_index
  index of performance variable for which handle is to be allocated (integer)
obj_handle
  reference to a handle of the MPI object to which this variable is supposed to be bound (pointer)

## Output Parameters

handle
  allocated handle (handle)
count
  number of elements used to represent this variable (integer)

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

MPI_T_ERR_NOT_INITIALIZED
  The MPI tool information interface is not initialized.

MPI_T_ERR_INVALID_SESSION
  Session argument is not valid.

MPI_T_ERR_INVALID_INDEX
  Index is invalid or has been deleted.

MPI_T_ERR_OUT_OF_HANDLES
  No more handles available.